#include "ready.h"

const std::chrono::seconds statusChangeInterval(15);

std::thread ready::get_status_thread(dpp::cluster &bot) {
    return std::thread([&bot]() {
        while (true) {
            bot.set_presence(dpp::presence(dpp::ps_online, dpp::at_watching, "support.sheepstar.xyz"));
            std::this_thread::sleep_for(statusChangeInterval);

            bot.set_presence(dpp::presence(dpp::ps_online, dpp::at_listening, "/help"));
            std::this_thread::sleep_for(statusChangeInterval);

            bot.set_presence(dpp::presence(dpp::ps_online, dpp::at_watching, "sheepstar.xyz"));
            std::this_thread::sleep_for(statusChangeInterval);
        }
    });
}

void ready::execute(dpp::cluster &bot, const dpp::ready_t &event) {
    std::cout << "Logged in as " << bot.me.username << " (" << bot.me.id << ")" << std::endl;

    std::thread status_thread = get_status_thread(bot);
    status_thread.detach();

    if (dpp::run_once<struct register_bot_commands>()) {
        bot.global_command_create(dpp::slashcommand("rules", "Shows you the rules of the global chat", bot.me.id));
        bot.global_command_create(dpp::slashcommand("add", "Transforms the channel into a global channel", bot.me.id));
        bot.global_command_create(
                dpp::slashcommand("remove", "Removes the channel from the global chat", bot.me.id).add_option(
                        dpp::command_option(dpp::co_channel, "channel", "The channel to remove", false)));
        bot.global_command_create(dpp::slashcommand("clear", "Removes all global channels", bot.me.id));
        bot.global_command_create(dpp::slashcommand("coins", "Gets the current amount of StarCoins", bot.me.id));

        dpp::command_option topic = dpp::command_option(dpp::co_string, "topic", "The topic of the global channel",true)
                .add_choice(dpp::command_option_choice("General", "1"))
                .add_choice(dpp::command_option_choice("Gaming", "2"))
                .add_choice(dpp::command_option_choice("Programming", "3"))
                .add_choice(dpp::command_option_choice("Politics", "4"));

        dpp::command_option language = dpp::command_option(dpp::co_string, "language", "The language of the global channel",true)
                .add_choice(dpp::command_option_choice("English", "en"))
                .add_choice(dpp::command_option_choice("German", "de"));

        bot.global_command_create(dpp::slashcommand("channel", "Test", bot.me.id)
                                          .add_option(dpp::command_option(dpp::co_sub_command, "topic","Changes the topic of the global channel").add_option(topic))
                                          .add_option(dpp::command_option(dpp::co_sub_command, "language","Changes the language of the global channel").add_option(language)));

        bot.global_command_create(dpp::slashcommand().set_name("Report User").set_type(dpp::ctxm_message));
    }
}
